from glut import *

from mpi4py import MPI
import numpy as np
import matplotlib.pyplot as plt
import time
from funcs import *
from helper import *

comm = MPI.COMM_WORLD
size= comm.Get_size(); me = comm.Get_rank()
pid_main = 0

np.random.seed(me)

## run export PYOPENGL_PLATFORM=osmesa

run_bool = True
# =========== main program for farmer-worker calculation

num_iter = 100



prey_count = np.zeros(num_iter)
pred_count = np.zeros(num_iter)
prey_sense_avg = np.zeros(num_iter)
prey_speed_avg = np.zeros(num_iter)
prey_energy_avg = np.zeros(num_iter)
pred_sense_avg = np.zeros(num_iter)
pred_speed_avg = np.zeros(num_iter)
pred_energy_avg = np.zeros(num_iter)

def init_main():    
    spawns_food = np.random.randint(low=[lim_x[0]+25,lim_y[0]+25],high=[lim_x[1]+26,lim_y[1]+26],size=(num_spawns_food,2)).astype(float)
    food = np.array([]).reshape((0,2))
    food = spawn_food(food,spawns_food,num_food)
    food_eaten = np.zeros(10)
    prey, prey_energy, prey_sense, prey_speed = init_blobs(num_prey,spawns = spawns_prey, role = 'prey')
    pred, pred_energy, pred_sense, pred_speed = init_blobs(num_pred, role = 'pred')
    start = time.time()
    return spawns_food, food,food_eaten, prey, prey_energy, prey_sense, prey_speed, pred, pred_energy, pred_sense, pred_speed, start


def GlutInit():
	glutInit()
	glutInitDisplayMode(GLUT_RGBA)
	glutInitWindowSize(WIDTH,HEIGHT)
	glutInitWindowPosition(0, 0)
	wind = glutCreateWindow("P&P")
	glutDisplayFunc(showScreen)
	glutReshapeFunc(reshape)
	glutIdleFunc(showScreen)
	glutMouseFunc(mouse)
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
	glEnable( GL_BLEND )
	glClearColor(1,1,1,1)
	glutMotionFunc(MPos)
	
def point(points,color,r):
	for i in points:
		posx, posy = i[0],i[1]
		glBegin(GL_POLYGON)
		if color == "green":
		    glColor3d(0,1,0)
		if color == "blue":
		    glColor3d(0,0,1)
		if color == "red":
		    glColor3d(1,0,0)
		for i in range(360):
			cury=math.sin(math.radians(i))*r
			curx=math.cos(math.radians(i))*r
			glVertex2f(posx+curx,posy+cury)
		glEnd()	
	
def run():
    global run_bool,start,prey,prey_energy,prey_sense,prey_speed,food,pred,pred_energy,pred_sense,pred_speed,food_eaten, gen,spawns_food
    calctime=time.time()
    
    if not start:
        return
    if calctime-start > 1/60:
        if len(prey) == 0 and num_prey != 0:
            print("extinction: prey in generation " + str(gen))
            run_bool = False
       	elif len(pred) == 0 and num_pred != 0:
            print("extinction: pred in generation " + str(gen))
            run_bool = False
        else:
            if num_prey != 0:
                prey_count[gen] = len(prey)
                prey_sense_avg[gen] = sum(prey_sense)/len(prey_sense)
                prey_speed_avg[gen] = sum(prey_speed)/len(prey_speed)
                prey_energy_avg[gen] = sum(prey_energy)/len(prey_energy)
            if num_pred != 0:
                pred_count[gen] = len(pred)
                pred_sense_avg[gen] = sum(pred_sense)/len(pred_sense)
                pred_speed_avg[gen] = sum(pred_speed)/len(pred_speed)
                pred_energy_avg[gen] = sum(pred_energy)/len(pred_energy)    
        calc = time.time()
        
        prey,prey_energy,prey_sense,prey_speed,food,pred,pred_energy,pred_sense,pred_speed,food_eaten = iter_step_main(gen,prey,prey_energy,prey_sense,prey_speed,food,pred,pred_energy,pred_sense,pred_speed,food_eaten,spawns_food)
        
        print("gen:",gen,"took:",time.time()-calc)
        gen += 1
        if gen >=num_iter:
            run_bool = False
        start=time.time()
		
		
	
def showScreen():
    global prey,pred,food
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
    glLoadIdentity()
    if run_bool:
        run()
        print(time.time()-START)
    point(food,"green",5)
    point(prey,"blue",10)
    point(pred,"red",10)

    glutSwapBuffers()

def reshape(width,height):
	glMatrixMode(GL_PROJECTION)
	glLoadIdentity()
	w=int(height*ASPECT)
	left = int((width - w) / 2);
	glViewport(left, 0, w, height)
	gluOrtho2D(0, WIDTH, 0, HEIGHT)
	glMatrixMode(GL_MODELVIEW)
	glutPostRedisplay()


if me == pid_main:
    
    gen = 0
    spawns_food, food,food_eaten, prey, prey_energy, prey_sense, prey_speed, pred, pred_energy, pred_sense, pred_speed, start = init_main()
    GlutInit()
    glutReshapeWindow(1024,1024)
    start=time.time()
    time.sleep(0.1)
    START = time.time()
    run()
    glPointSize(2.0)
    glutMainLoop()
    
if me != pid_main:
    for i in range(num_iter):
        iter_step_worker()
        


