from OpenGL.GL import *
from OpenGL.GLUT import *
from OpenGL.GLU import *
import OpenGL.arrays.vbo as glvbo
import PIL
from PIL import Image

WIDTH,HEIGHT=1024,1024
ASPECT=WIDTH/HEIGHT

import numpy as np
import time
import math
import os
import matplotlib.pyplot as plt

WIDTH,HEIGHT=1024,1024
ASPECT=WIDTH/HEIGHT

draws=[]
buttons=[]
sliders=[]
textures=dict()
mp=False
curslider=None


def mouse(button,state,x,y):
	global mp,curslider
	invy=np.matrix([[1,0,0,0],[0,-1,0,0],[0,0,1,0],[0,0,0,1]])
	model=glGetDoublev(GL_MODELVIEW_MATRIX)
	proj=glGetDoublev(GL_PROJECTION_MATRIX)
	view=glGetIntegerv(GL_VIEWPORT)
	unproj=gluUnProject(x,y,0,model,proj @ invy,view)
	posx,posy=unproj[0],unproj[1]
	if button==GLUT_LEFT_BUTTON:
		if state==GLUT_DOWN:
			#print("Pressed at ("+str(posx)+","+str(posy)+")")
			for i in buttons:
				if posx >= i.start[0] and posx <= i.stop[0] and posy >= i.start[1] and posy <= i.stop[1]:
					i.func()
					return
			for i in sliders:
				if i.show==False:
					continue
				if i.type=='h':
					if posx >= i.startc[0] and posx <= i.stopc[0] and posy >= i.startc[1] and posy <= i.stopc[1]:
						mp=True
						curslider=i
						curslider.sliderpos=(posx-curslider.start)/curslider.range
						curslider.update()
						return
				else:
					if posy >= i.startc[0] and posy <= i.stopc[0] and posx >= i.startc[1] and posx <= i.stopc[1]:
						mp=True
						curslider=i
						curslider.sliderpos=(posy-curslider.start)/curslider.range
						curslider.update()
						return	
		else:
			#print("Released at ("+str(unproj[0])+","+str(unproj[1])+")")
			mp=False
			
def MPos(x,y):
	if not mp or curslider is None:
		return
	invy=np.matrix([[1,0,0,0],[0,-1,0,0],[0,0,1,0],[0,0,0,1]])
	model=glGetDoublev(GL_MODELVIEW_MATRIX)
	proj=glGetDoublev(GL_PROJECTION_MATRIX)
	view=glGetIntegerv(GL_VIEWPORT)
	unproj=gluUnProject(x,y,0,model,proj @ invy,view)
	posx,posy=unproj[0],unproj[1]
	if curslider.type == 'h':
		if posx >= curslider.startc[0] and posx <= curslider.stopc[0]:
			curslider.sliderpos=(posx-curslider.start)/curslider.range
			curslider.update()
	else:
		if posy >= curslider.startc[0] and posy <= curslider.stopc[0]:
			curslider.sliderpos=(posy-curslider.start)/curslider.range
			curslider.update()


def loadImage(file):
	img = Image.open("Textures/"+file)
	img=img.transpose(Image.FLIP_TOP_BOTTOM)
	img_data = np.array(list(img.getdata()), np.int8)
	textID = glGenTextures(1)
	textures[file]=textID
	glBindTexture(GL_TEXTURE_2D, textID)
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1)
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP)
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP)
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT)
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT)
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST)
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST)
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL)
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, img.size[0], img.size[1], 0, GL_RGBA, GL_UNSIGNED_BYTE, img_data)
	return textID
	
class slider:
	def __init__(self,stype,start,stop,posi,startvalue,stopvalue,stops,var):
		self.var=var
		self.type=stype
		self.start=start
		self.stop=stop
		self.pos=posi
		self.startv=startvalue
		self.stopv=stopvalue
		self.stops=np.linspace(start,stop,stops)
		self.range=stop-start
		self.sliderpos=var[0]/(self.stopv-self.startv)
		draws.append(self)
		sliders.append(self)
		self.show=True
		self.startc=(self.start,int(self.pos-self.range*0.05))
		self.stopc=(self.stop,int(self.pos+self.range*0.05))
	def update(self):
		if type(self.var[0])==int:
			self.var[0]=int(np.round((self.stopv-self.startv)*self.sliderpos+self.startv))
		else:
			self.var[0]=np.round((self.stopv-self.startv)*self.sliderpos+self.startv,1)
	def draw(self):
		if self.type=='h':
			self.drawh()
		elif self.type=='v':
			self.drawv()
	def drawh(self):
		glBegin(GL_LINES)
		glColor3f(0,0,0)
		glVertex2f(self.start,self.pos)
		glVertex2f(self.stop,self.pos)
		glVertex2f(self.start,int(self.pos-self.range*0.05))
		glVertex2f(self.start,int(self.pos+self.range*0.05))
		glVertex2f(self.stop,int(self.pos-self.range*0.05))
		glVertex2f(self.stop,int(self.pos+self.range*0.05))
		for i in self.stops:
			glVertex2f(i,self.pos+self.range*0.025)
			glVertex2f(i,self.pos-self.range*0.025)
		glEnd()
		glBegin(GL_QUADS)
		glColor4f(0.5,0,0,0.7)
		glVertex2f(self.start+self.sliderpos*self.range-self.range*0.015,self.pos-self.range*0.035)
		glVertex2f(self.start+self.sliderpos*self.range-self.range*0.015,self.pos+self.range*0.035)
		glVertex2f(self.start+self.sliderpos*self.range+self.range*0.015,self.pos+self.range*0.035)
		glVertex2f(self.start+self.sliderpos*self.range+self.range*0.015,self.pos-self.range*0.035)
		glEnd()
	def drawv(self):
		glBegin(GL_LINES)
		glColor3f(0,0,0)
		glVertex2f(self.pos,self.start)
		glVertex2f(self.pos,self.stop)
		glVertex2f(self.pos-self.range*0.05,self.start)
		glVertex2f(self.pos+self.range*0.05,self.start)
		glVertex2f(self.pos-self.range*0.05,self.stop)
		glVertex2f(self.pos+self.range*0.05,self.stop)
		for i in self.stops:
			glVertex2f(self.pos+self.range*0.025,i)
			glVertex2f(self.pos-self.range*0.025,i)
		glEnd()
		glBegin(GL_QUADS)
		glColor4f(0.5,0,0,0.7)
		glVertex2f(self.pos-self.range*0.035,self.start+self.sliderpos*self.range-self.range*0.015)
		glVertex2f(self.pos+self.range*0.035,self.start+self.sliderpos*self.range-self.range*0.015)
		glVertex2f(self.pos+self.range*0.035,self.start+self.sliderpos*self.range+self.range*0.015)
		glVertex2f(self.pos-self.range*0.035,self.start+self.sliderpos*self.range+self.range*0.015)
		glEnd()

class button:
	def __init__(self,start,stop,file,func):
		self.start=start
		self.stop=stop
		self.tex=textures[file]
		self.func=func
		self.show=True
		draws.append(self)
		buttons.append(self)
		
	def draw(self):
		glEnable(GL_TEXTURE_2D)
		glBindTexture(GL_TEXTURE_2D, self.tex)
		glBegin(GL_QUADS)
		glColor4d(0,0,0,1)
		glTexCoord2f(0.0, 0.0);	glVertex2f(self.start[0],self.start[1]);
		glTexCoord2f(0.0, 1.0);	glVertex2f(self.start[0],self.stop[1]);
		glTexCoord2f(1.0, 1.0);	glVertex2f(self.stop[0],self.stop[1]);
		glTexCoord2f(1.0, 0.0);	glVertex2f(self.stop[0],self.start[1]);
		glEnd()
		glDisable(GL_TEXTURE_2D)



