from mpi4py import MPI
import numpy as np
import matplotlib.pyplot as plt
import time
from funcs import *


comm = MPI.COMM_WORLD
size= comm.Get_size(); me = comm.Get_rank()
pid_main = 0; idle = 0; pia = 0.; n=0; ndom=0

prey_eat = 1 
pred_eat = 10


def iter_step_worker():
### WORKER PROCESS
   
    ## receive data from main process
    prey = comm.recv(source=0, tag=11)
    prey_energy = comm.recv(source=0, tag=12)
    prey_sense = comm.recv(source=0, tag=13)
    prey_speed = comm.recv(source=0, tag=14)
    food = comm.recv(source=0, tag=15)
    pred = comm.recv(source=0, tag=16)
    pred_energy = comm.recv(source=0, tag=17)
    pred_sense = comm.recv(source=0, tag=18)
    pred_speed = comm.recv(source=0, tag=19)
    prey_boxes = comm.recv(source=0, tag=31)
    pred_boxes = comm.recv(source=0, tag=32)
    food_boxes = comm.recv(source=0, tag=33)
                   
    l = len(prey_boxes)
    l = l//(size-1)
    if me == size-1:
        my_prey_boxes = prey_boxes[(me-1)*l:]
        my_pred_boxes = pred_boxes[(me-1)*l:]
        my_food_boxes = food_boxes[(me-1)*l:]
    else:
        my_prey_boxes = prey_boxes[(me-1)*l:l*me]
        my_pred_boxes = pred_boxes[(me-1)*l:l*me]
        my_food_boxes = food_boxes[(me-1)*l:l*me]
            
    my_prey = []
    my_prey_energy = [] 
    my_pred = []
    my_pred_energy = [] 
    my_prey_idx = []
    my_pred_idx = []
        
    prey_want_to_eat = []
    pred_want_to_eat = []    
    prey_prey_dist = []
    pred_pred_dist = []
    prey_pred_dist = []
    pred_prey_dist = []
    ## for each creature find everything in it's sensing distance     
    for box_idx in range(len(my_prey_boxes)):
        prey_box_wte = []
        pred_box_wte = []
        my_idx = (me-1)*l
        box_prey = prey_boxes[my_idx+box_idx].copy() 
        box_prey[0] = np.concatenate((box_prey[0],prey_boxes[((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx+1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][0]))
        box_prey[1] = np.concatenate((box_prey[1],prey_boxes[((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx+1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][1]))
        box_prey[0] = np.concatenate((box_prey[0],prey_boxes[((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx-1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][0]))
        box_prey[1] = np.concatenate((box_prey[1],prey_boxes[((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx-1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][1]))
        box_prey[0] = np.concatenate((box_prey[0],prey_boxes[(((1+((my_idx+box_idx)//int(np.sqrt(len(prey_boxes)))))*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx+1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][0]))
        box_prey[1] = np.concatenate((box_prey[1],prey_boxes[(((1+((my_idx+box_idx)//int(np.sqrt(len(prey_boxes)))))*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx+1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][1]))
        box_prey[0] = np.concatenate((box_prey[0],prey_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))-1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx-1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][0]))
        box_prey[1] = np.concatenate((box_prey[1],prey_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))-1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx-1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][1]))
        box_prey[0] = np.concatenate((box_prey[0],prey_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))+1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx-1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][0]))
        box_prey[1] = np.concatenate((box_prey[1],prey_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))+1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx-1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][1]))
        box_prey[0] = np.concatenate((box_prey[0],prey_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))-1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx+1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][0]))
        box_prey[1] = np.concatenate((box_prey[1],prey_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))-1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx+1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][1]))
        box_prey[0] = np.concatenate((box_prey[0],prey_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))-1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][0]))
        box_prey[1] = np.concatenate((box_prey[1],prey_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))-1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][1]))
        box_prey[0] = np.concatenate((box_prey[0],prey_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))+1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][0]))
        box_prey[1] = np.concatenate((box_prey[1],prey_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))+1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][1]))
        box_pred = pred_boxes[my_idx+box_idx].copy() 
        box_pred[0] = np.concatenate((box_pred[0],pred_boxes[(((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx+1)%int(np.sqrt(len(prey_boxes)))][0]))
        box_pred[1] = np.concatenate((box_pred[1],pred_boxes[((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx+1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][1]))
        box_pred[0] = np.concatenate((box_pred[0],pred_boxes[((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx-1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][0]))
        box_pred[1] = np.concatenate((box_pred[1],pred_boxes[((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx-1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][1]))
        box_pred[0] = np.concatenate((box_pred[0],pred_boxes[(((1+((my_idx+box_idx)//int(np.sqrt(len(prey_boxes)))))*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx+1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][0]))
        box_pred[1] = np.concatenate((box_pred[1],pred_boxes[(((1+((my_idx+box_idx)//int(np.sqrt(len(prey_boxes)))))*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx+1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][1]))
        box_pred[0] = np.concatenate((box_pred[0],pred_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))-1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx-1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][0]))
        box_pred[1] = np.concatenate((box_pred[1],pred_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))-1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx-1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][1]))
        box_pred[0] = np.concatenate((box_pred[0],pred_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))+1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx-1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][0]))
        box_pred[1] = np.concatenate((box_pred[1],pred_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))+1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx-1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][1]))
        box_pred[0] = np.concatenate((box_pred[0],pred_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))-1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx+1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][0]))
        box_pred[1] = np.concatenate((box_pred[1],pred_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))-1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx+1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][1]))
        box_pred[0] = np.concatenate((box_pred[0],pred_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))-1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][0]))
        box_pred[1] = np.concatenate((box_pred[1],pred_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))-1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][1]))
        box_pred[0] = np.concatenate((box_pred[0],pred_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))+1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][0]))
        box_pred[1] = np.concatenate((box_pred[1],pred_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))+1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][1]))
        box_food = food_boxes[my_idx+box_idx].copy() 
        box_food[0] = np.concatenate((box_food[0],food_boxes[((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx+1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][0]))
        box_food[0] = np.concatenate((box_food[0],food_boxes[((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx-1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][0]))
        box_food[0] = np.concatenate((box_food[0],food_boxes[(((1+((my_idx+box_idx)//int(np.sqrt(len(prey_boxes)))))*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx+1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][0]))
        box_food[0] = np.concatenate((box_food[0],food_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))-1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx-1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][0]))
        box_food[0] = np.concatenate((box_food[0],food_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))+1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx-1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][0]))
        box_food[0] = np.concatenate((box_food[0],food_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))-1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx+1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][0]))
        box_food[0] = np.concatenate((box_food[0],food_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))-1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][0]))
        box_food[0] = np.concatenate((box_food[0],food_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))+1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][0]))
        box_food[1] = np.concatenate((box_food[1],food_boxes[((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx+1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][1]))
        box_food[1] = np.concatenate((box_food[1],food_boxes[((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx-1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][1]))
        box_food[1] = np.concatenate((box_food[1],food_boxes[(((1+((my_idx+box_idx)//int(np.sqrt(len(prey_boxes)))))*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx+1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][1]))
        box_food[1] = np.concatenate((box_food[1],food_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))-1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx-1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][1]))
        box_food[1] = np.concatenate((box_food[1],food_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))+1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx-1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][1]))
        box_food[1] = np.concatenate((box_food[1],food_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))-1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx+1)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][1]))
        box_food[1] = np.concatenate((box_food[1],food_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))-1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][1]))
        box_food[1] = np.concatenate((box_food[1],food_boxes[(((((my_idx+box_idx)//int(np.sqrt(len(prey_boxes))))+1)*int(np.sqrt(len(prey_boxes))))+(my_idx+box_idx)%int(np.sqrt(len(prey_boxes))))%len(prey_boxes)][1]))
      
        
        box_prey_energy = np.zeros(len(my_prey_boxes[box_idx][1]))
        box_prey_sense = np.zeros(len(my_prey_boxes[box_idx][1]))
        box_prey_speed = np.zeros(len(my_prey_boxes[box_idx][1]))
        box_pred_energy = np.zeros(len(my_pred_boxes[box_idx][1]))
        box_pred_sense = np.zeros(len(my_pred_boxes[box_idx][1]))
        box_pred_speed = np.zeros(len(my_pred_boxes[box_idx][1]))
        
        for idx,prey_idx in enumerate(my_prey_boxes[box_idx][1]):
            box_prey_energy[idx] = prey_energy[prey_idx]
            box_prey_sense[idx] = prey_sense[prey_idx]
            box_prey_speed[idx] = prey_speed[prey_idx]
        for idx,pred_idx in enumerate(my_pred_boxes[box_idx][1]):
            box_pred_energy[idx] = pred_energy[pred_idx]
            box_pred_sense[idx] = pred_sense[pred_idx]
            box_pred_speed[idx] = pred_speed[pred_idx]
        
        
        for [creature,energy,sense,speed,role] in [[my_prey_boxes[box_idx],box_prey_energy,box_prey_sense,box_prey_speed,"prey"],[my_pred_boxes[box_idx],box_pred_energy,box_pred_sense,box_pred_speed,"pred"]]:
        
            if len(creature[0]) == 0: continue
            
            
            near_food = []
            near_prey = []
            near_pred = []
            if role == 'prey':
                prey_box_wte = np.zeros((len(my_prey_boxes[box_idx][0]),2))
            if role == 'pred':
                pred_box_wte = np.zeros((len(my_pred_boxes[box_idx][0]),2))
            nearest_prey = np.zeros((len(my_prey_boxes[box_idx][0]),2))
            nearest_pred = np.zeros((len(my_prey_boxes[box_idx][0]),2))
            
            for prey_idx in range(len(creature[0])):
                
                
                dist_food = np.zeros(box_food[0].shape)
                for j in range(len(box_food[0])):
                    dist_food[j,0] = np.min((box_food[0][j,0] - creature[0][prey_idx][0], lim_x[1]-(box_food[0][j,0] - creature[0][prey_idx][0])))
                    dist_food[j,1] = np.min((box_food[0][j,1] - creature[0][prey_idx][1], lim_y[1]-(box_food[0][j,1] - creature[0][prey_idx][1])))
                dist_food = dist_food**2
                dist_food = dist_food[:,0]+dist_food[:,1]
                dist_food = np.stack((dist_food,np.arange(len(dist_food))),axis=1)
                dist_food = dist_food[dist_food[:, 0].argsort()]
                idx = np.count_nonzero(dist_food[:,0] < sense[prey_idx]**2)
                near_food.append(dist_food[:idx,1])
                if role == 'prey':
                    if len(dist_food) == 0:
                        prey_box_wte[prey_idx] = [np.Infinity, None]
                    else:
                        prey_box_wte[prey_idx] = dist_food[0,:]
                        prey_box_wte[prey_idx,1] = box_food[1][int(prey_box_wte[prey_idx,1])]
    	    
                dist_prey = np.zeros(box_prey[0].shape)
                for j in range(len(box_prey[0])):
                #for j in range(prey_idx,len(box_prey[0])):
                    dist_prey[j,0] = np.min((box_prey[0][j,0] - creature[0][prey_idx][0], lim_x[1]-(box_prey[0][j,0] - creature[0][prey_idx][0])))
                    dist_prey[j,1] = np.min((box_prey[0][j,1] - creature[0][prey_idx][1], lim_y[1]-(box_prey[0][j,1] - creature[0][prey_idx][1])))
                dist_prey = dist_prey**2
                dist_prey = dist_prey[:,0]+dist_prey[:,1]
                dist_prey = np.stack((dist_prey,np.arange(len(dist_prey))),axis=1)
                dist_prey = dist_prey[dist_prey[:, 0].argsort()]
                idx = np.count_nonzero(dist_prey[:,0] < sense[prey_idx]**2)
                if role == 'prey':    
                    near_prey.append(dist_prey[1:idx,1])
                    if prey_prey_dist == []:
                        for dist in dist_prey:
                            prey_prey_dist = [[box_prey[1][prey_idx],box_prey[1][int(dist[1])],dist[0]]]
                    else:
                        for dist in dist_prey:
                            prey_prey_dist.append([box_prey[1][prey_idx],box_prey[1][int(dist[1])],dist[0]])
                if role == 'pred':
                    if len(dist_prey) == 0:
                        near_prey.append([])
                        pred_box_wte[prey_idx] = [np.Infinity, None]
                    else:
                        if pred_prey_dist == []:
                            for dist in dist_prey:
                                pred_prey_dist = [[box_pred[1][prey_idx],box_prey[1][int(dist[1])],dist[0]]]
                        else:
                            for dist in dist_prey:
                                pred_prey_dist.append([box_pred[1][prey_idx],box_prey[1][int(dist[1])],dist[0]])
                        near_prey.append(dist_prey[:idx,1])
                        pred_box_wte[prey_idx] = dist_prey[0,:]
                        pred_box_wte[prey_idx,1] = box_prey[1][int(pred_box_wte[prey_idx,1])]
                        
                dist_pred = np.zeros(box_pred[0].shape)
               
                for j in range(len(box_pred[0])):
                    dist_pred[j,0] = np.min((box_pred[0][j,0] - creature[0][prey_idx][0], lim_x[1]-(box_pred[0][j,0] - creature[0][prey_idx][0])))
                    dist_pred[j,1] = np.min((box_pred[0][j,1] - creature[0][prey_idx][1], lim_y[1]-(box_pred[0][j,1] - creature[0][prey_idx][1])))
                dist_pred = dist_pred**2
                dist_pred = dist_pred[:,0]+dist_pred[:,1]
                dist_pred = np.stack((dist_pred,np.arange(len(dist_pred))),axis=1)
                dist_pred = dist_pred[dist_pred[:, 0].argsort()]
                idx = np.count_nonzero(dist_pred[:,0] < sense[prey_idx]**2)
                near_pred.append(dist_pred[1:idx,1])
                if role == 'prey':
                    near_pred.append(dist_pred[:idx,1])
                    if prey_pred_dist == []:
                        for dist in dist_pred:
                            prey_pred_dist = [[box_prey[1][prey_idx],box_pred[1][int(dist[1])],dist[0]]]
                    else:
                        for dist in dist_pred:
                            prey_pred_dist.append([box_prey[1][prey_idx],box_pred[1][int(dist[1])],dist[0]])
                else:
                    if pred_pred_dist == []:
                        for dist in dist_pred:
                            pred_pred_dist = [[box_pred[1][prey_idx],box_pred[1][int(dist[1])],dist[0]]]
                    else:
                        for dist in dist_pred:
                            pred_pred_dist.append([box_pred[1][prey_idx],box_pred[1][int(dist[1])],dist[0]])
            
            
            box_creature,box_energy = move(creature[0],box_prey[0],box_pred[0],energy,sense,speed,box_food[0],near_food,near_prey,near_pred,role)

            if (len(my_prey) == 0 and role == 'prey') or (len(my_pred) == 0 and role == 'pred'):
                if role == 'prey': 
                    my_prey, my_prey_energy,my_prey_idx = box_creature, box_energy, creature[1]
                    for wte in prey_box_wte:
                        prey_want_to_eat.append(wte)
                elif role == 'pred': 
                    my_pred, my_pred_energy,my_pred_idx = box_creature, box_energy, creature[1]
                    for wte in pred_box_wte:
                        pred_want_to_eat.append(wte)
                           
            else:
                if role == 'prey': 
                    my_prey, my_prey_energy,my_prey_idx = np.concatenate((my_prey,box_creature)), np.concatenate((my_prey_energy,box_energy)), np.concatenate((my_prey_idx,creature[1]))
                    for wte in prey_box_wte:
                        prey_want_to_eat.append(wte)
                elif role == 'pred': 
                    my_pred, my_pred_energy,my_pred_idx = np.concatenate((my_pred,box_creature)), np.concatenate((my_pred_energy,box_energy)), np.concatenate((my_pred_idx,creature[1]))
                    for wte in pred_box_wte:
                        pred_want_to_eat.append(wte)  
        
    ## send all generated data back	
    comm.send(my_prey, dest=0, tag=21)
    comm.send(my_prey_energy, dest=0, tag=22)
    comm.send(prey_sense, dest=0, tag=23)
    comm.send(prey_speed, dest=0, tag=24)
    comm.send(my_pred, dest=0, tag=26)
    comm.send(my_pred_energy, dest=0, tag=27)
    comm.send(pred_sense, dest=0, tag=28)
    comm.send(pred_speed, dest=0, tag=29)
    comm.send(my_prey_idx, dest=0, tag=30)
    comm.send(my_pred_idx, dest=0, tag=31)
    comm.send(prey_want_to_eat, dest=0, tag=50)
    comm.send(pred_want_to_eat, dest=0, tag=51)   
### WORKER PROCESS 

def iter_step_main(gen,prey,prey_energy,prey_sense,prey_speed,food,pred,pred_energy,pred_sense,pred_speed,food_eaten,spawns_food):       
### MAIN PROCESS
    x_count = min([lim_x[1]//max(prey_sense), lim_x[1]//max(pred_sense)])
    y_count = min([lim_y[1]//max(prey_sense), lim_y[1]//max(pred_sense)])
    x_len = (lim_x[1]/x_count)+1
    y_len = (lim_y[1]/y_count)+1
    
    prey_boxes = get_boxes(x_count,x_len,y_count,y_len,prey)
    pred_boxes = get_boxes(x_count,x_len,y_count,y_len,pred)
    food_boxes = get_boxes(x_count,x_len,y_count,y_len,food)
  
    ## send data to worker processes
    for i in range(1,size):
        comm.send(prey,dest=i, tag=11)
        comm.send(prey_energy,dest=i, tag=12)
        comm.send(prey_sense,dest=i, tag=13)
        comm.send(prey_speed,dest=i, tag=14)
        comm.send(food,dest=i, tag=15)
        comm.send(pred,dest=i, tag=16)
        comm.send(pred_energy,dest=i, tag=17)
        comm.send(pred_sense,dest=i, tag=18)
        comm.send(pred_speed,dest=i, tag=19)
        comm.send(prey_boxes, dest=i, tag=31)
        comm.send(pred_boxes, dest=i, tag=32)
        comm.send(food_boxes, dest=i, tag=33)  
    ## recollect data from worker processes
    buf = np.array([]).reshape((0,2))
    buf2 = np.array([]).reshape((0))
    buf3 = np.array([]).reshape((0))
    buf4 = np.array([]).reshape((0))
    buf6 = np.array([]).reshape((0,2))
    buf7 = np.array([]).reshape((0))
    buf8 = np.array([]).reshape((0))
    buf9 = np.array([]).reshape((0))
    buf30 = np.array([]).reshape((0))
    buf31 = np.array([]).reshape((0))
    buf50 = np.array([]).reshape((0,2))
    buf51 = np.array([]).reshape((0,2))
    for i in range(1,size):
        
        prey = comm.recv(source=i, tag=21)
        prey_energy = comm.recv(source=i, tag=22)
        prey_sense = comm.recv(source=i, tag=23)
        prey_speed = comm.recv(source=i, tag=24)
        pred = comm.recv(source=i, tag=26)
        pred_energy = comm.recv(source=i, tag=27)
        pred_sense = comm.recv(source=i, tag=28)
        pred_speed = comm.recv(source=i, tag=29)
        prey_idx = comm.recv(source = i, tag=30)
        pred_idx = comm.recv(source = i, tag=31)
        prey_want_to_eat = comm.recv(source=i, tag=50)
        pred_want_to_eat = comm.recv(source=i, tag=51)

        if len(prey) > 0:
            buf = np.concatenate((buf,prey),axis=0)
            buf2 = np.concatenate((buf2,prey_energy),axis=0)
            buf3 = np.concatenate((buf3,prey_sense),axis=0)
            buf4 = np.concatenate((buf4,prey_speed),axis=0)
            buf30 = np.concatenate((buf30,prey_idx),axis=0)
            buf50 = np.concatenate((buf50,prey_want_to_eat),axis=0)
        if len(pred) > 0:
            buf6 = np.concatenate((buf6,pred),axis=0)
            buf7 = np.concatenate((buf7,pred_energy),axis=0)
            buf8 = np.concatenate((buf8,pred_sense),axis=0)
            buf9 = np.concatenate((buf9,pred_speed),axis=0)
            buf31 = np.concatenate((buf31,pred_idx),axis=0)
            buf51 = np.concatenate((buf51,pred_want_to_eat),axis=0)
    prey = buf
    prey_energy = buf2
    pred = buf6
    pred_energy = buf7
    prey_idx = buf30
    pred_idx = buf31
    prey_want_to_eat = buf50
    pred_want_to_eat = buf51
    
    prey_sort = prey.copy()
    prey_energy_sort = prey_energy.copy()
    prey_wte_sort = prey_want_to_eat.copy()

    for i,v in enumerate(prey_idx):
        prey_sort[int(v)] = prey[i]
        prey_energy_sort[int(v)] = prey_energy[i]
        prey_wte_sort[int(v)] = prey_want_to_eat[i]
    pred_sort = pred.copy()
    pred_energy_sort = pred_energy.copy()
    pred_wte_sort = pred_want_to_eat.copy()
    
    for i,v in enumerate(pred_idx):
        pred_sort[int(v)] = pred[i]
        pred_energy_sort[int(v)] = pred_energy[i]
        pred_wte_sort[int(v)] = pred_want_to_eat[i]
    prey = prey_sort
    prey_energy = prey_energy_sort
    prey_want_to_eat = prey_wte_sort
    pred = pred_sort
    pred_energy = pred_energy_sort
    pred_want_to_eat = pred_wte_sort
    
    ## prey and predator eat
    want_to_eat = [prey_want_to_eat,pred_want_to_eat]
    eat = [prey_eat,pred_eat]
    energy = [prey_energy, pred_energy]
    prey_eaten = 0
    food_eaten_it = 0
    for j in [0,1]:      
        can_eat = want_to_eat[j][:,0]<eat[j]**2
        can_eat_idx = np.arange(len(want_to_eat[j]))[can_eat]
        already_eaten=[]
        for i in can_eat_idx:
            if want_to_eat[j][i,1] in already_eaten:
                continue
            count = np.count_nonzero(want_to_eat[j][i,1]==want_to_eat[j][can_eat_idx,1])
            if count == 1:
                if j == 0 and food[int(want_to_eat[j][i,1])][0] != np.inf:
                    food[int(want_to_eat[j][i,1])] = np.array([np.inf,np.inf])
                    prey_energy[i] += 100
                    food_eaten_it += 1
                elif j == 1 and prey_energy[int(want_to_eat[j][i,1])] > 0:
                    pred_energy[i] += prey_energy[int(want_to_eat[j][i,1])] + 80
                    prey_energy[int(want_to_eat[j][i,1])] = 0
                    prey_eaten += 1

            else:
                decide = np.random.randint(count)
                decide = np.nonzero(want_to_eat[j][i,1]==want_to_eat[j][can_eat_idx,1])[0][decide]
                if j == 0 and food[int(want_to_eat[j][int(decide),1])][0] != np.inf:
                    food[int(want_to_eat[j][int(decide),1])] = np.array([np.inf,np.inf])
                    prey_energy[decide] += 100
                    food_eaten_it += 1
                elif j == 1 and prey_energy[int(want_to_eat[j][i,1])] > 0 :
                    pred_energy[i] += prey_energy[int(want_to_eat[j][i,1])] + 80
                    prey_energy[int(want_to_eat[j][i,1])] = 0
                    prey_eaten += 1
                already_eaten.append(want_to_eat[j][decide,1])
   
    food = np.delete(food,np.nonzero(food[:,0] == np.inf),axis=0)

    
    ## update food and creatures
    prey,prey_energy,prey_sense,prey_speed = check_alive(prey,prey_energy,prey_sense,prey_speed,)
    pred,pred_energy,pred_sense,pred_speed = check_alive(pred,pred_energy,pred_sense,pred_speed,)

    food_eaten = np.concatenate((food_eaten[1:10], [food_eaten_it]))
    food = spawn_food(food,spawns_food,food_eaten[0])

    prey,prey_energy,prey_sense,prey_speed = reproduce(prey,prey_energy,prey_sense,prey_speed,'prey')
    pred,pred_energy,pred_sense,pred_speed = reproduce(pred,pred_energy,pred_sense,pred_speed,'pred')

    return prey,prey_energy,prey_sense,prey_speed,food,pred,pred_energy,pred_sense,pred_speed,food_eaten
