import numpy as np
import matplotlib.pyplot as plt
import time

lim_x = (0,1024)
lim_y = (0,1024)

num_prey = 100
num_pred = 20
num_food = 100
num_spawns_food = 110
spawns_prey = 40

def move(creature,prey,pred,energy,sense,speed,food,near_food=None, near_prey=None, near_pred=None, role = 'prey'):
    
    ## choose random move
    creature = creature.copy()
    energy = energy.copy()
    np.random.seed(0)
    move_vec = np.array([np.random.normal(loc = 0, scale = s,size = 2) for s in speed])
    
    if role == 'prey':
        dest = near_food
        for i in range(len(creature)):
        ## if energy is near and food is low or no predator near -> move to food
            if len(dest[i]) != 0 and len(near_pred[i])==0 :
                move_to_food = food[int(near_food[i][0])]           
                move_to_food = move_to_food - creature[i]
                if np.abs(move_to_food[0]) > (lim_x[1]/2): move_to_food[0] *= -1
                if np.abs(move_to_food[1]) > (lim_y[1]/2): move_to_food[1] *= -1
                if np.linalg.norm(move_to_food) > np.linalg.norm(move_vec[i]):
                    move_vec[i] = move_to_food*(np.linalg.norm(move_vec[i]) / np.linalg.norm(move_to_food))
                else:
                    move_vec[i] = np.copy(move_to_food)
        
            ## if predator is near, flee        
            elif len(near_pred[i]) != 0: #and energy > 70:
                move_away = pred[int(near_pred[i][0])]
                move_away = move_away - creature[i]
                if np.abs(move_away[0]) > (lim_x[1]/2): move_away[0] *= -1
                if np.abs(move_away[1]) > (lim_y[1]/2): move_away[1] *= -1
                if np.linalg.norm(move_away) != 0:
                    move_vec[i] = -1*(move_away*(np.linalg.norm(move_vec[i]) / np.linalg.norm(move_away)))
                
            elif len(near_prey[i])!=0:
                move_away = prey[int(near_prey[i][0])]
                move_away = move_away - creature[i]
                if np.abs(move_away[0]) > (lim_x[1]/2): move_away[0] *= -1
                if np.abs(move_away[1]) > (lim_y[1]/2): move_away[1] *= -1
                if np.linalg.norm(move_away) != 0:
                    move_vec[i] = -1*(move_away*(np.linalg.norm(move_vec[i]) / np.linalg.norm(move_away)))
            
            #border checks        
            if creature[i][0]+move_vec[i][0] < lim_x[0]:
                creature[i][0] = lim_x[1]+creature[i][0]+move_vec[i][0]
            elif creature[i][0]+move_vec[i][0] > lim_x[1]:
                creature[i][0] = creature[i][0]+move_vec[i][0]-lim_x[1]
            else:
                creature[i][0] = creature[i][0]+move_vec[i][0]
            
            if creature[i][1]+move_vec[i][1] < lim_y[0]:
                creature[i][1] = lim_y[1]+creature[i][1]+move_vec[i][1]
            elif creature[i][1]+move_vec[i][1] > lim_y[1]:
                creature[i][1] = creature[i][1]+move_vec[i][1]-lim_y[1]
            else:
                creature[i][1] = creature[i][1]+move_vec[i][1]
        


    elif role == 'pred':
        dest = near_prey
    ## check if food sensed, if so move in its direction
        for i in range(len(creature)):
            if (np.any(dest[i]))!=None and len(dest[i]) !=0:
                move_to_food = prey[int(near_prey[i][0])]
                move_to_food = move_to_food - creature[i]
                if np.abs(move_to_food[0]) > (lim_x[1]/2): move_to_food[0] *= -1
                if np.abs(move_to_food[1]) > (lim_y[1]/2): move_to_food[1] *= -1
                if np.linalg.norm(move_to_food) > np.linalg.norm(move_vec[i]):
                    move_vec[i] = move_to_food*(np.linalg.norm(move_vec[i]) / np.linalg.norm(move_to_food))
                else:
                    move_vec[i] = np.copy(move_to_food)
            
            elif len(near_pred[i])!=0:
                move_away = pred[int(near_pred[i][0])]
                move_away = move_away - creature[i]
                if np.abs(move_away[0]) > (lim_x[1]/2): move_away[0] *= -1
                if np.abs(move_away[1]) > (lim_y[1]/2): move_away[1] *= -1
                if np.linalg.norm(move_away) != 0:
                    move_vec[i] = -1*(move_away*(np.linalg.norm(move_vec[i]) / np.linalg.norm(move_away)))
                
            elif len(near_food[i])!=0: 
                move_to_food = food[int(near_food[i][0])]
                move_to_food = move_to_food - creature[i]
                if np.abs(move_to_food[0]) > (lim_x[1]/2): move_to_food[0] *= -1
                if np.abs(move_to_food[1]) > (lim_y[1]/2): move_to_food[1] *= -1
                if np.linalg.norm(move_to_food) > np.linalg.norm(move_vec[i]):
                    move_vec[i] = move_to_food*(np.linalg.norm(move_vec[i]) / np.linalg.norm(move_to_food))
                else:
                    move_vec[i] = np.copy(move_to_food)
            
            if creature[i][0]+move_vec[i][0] < lim_x[0]:
                creature[i][0] = lim_x[1]+creature[i][0]+move_vec[i][0]
            elif creature[i][0]+move_vec[i][0] > lim_x[1]:
                creature[i][0] = creature[i][0]+move_vec[i][0]-lim_x[1]
            else:
                creature[i][0] = creature[i][0]+move_vec[i][0]
            
            if creature[i][1]+move_vec[i][1] < lim_y[0]:
                creature[i][1] = lim_y[1]+creature[i][1]+move_vec[i][1]
            elif creature[i][1]+move_vec[i][1] > lim_y[1]:
                creature[i][1] = creature[i][1]+move_vec[i][1]-lim_y[1]
            else:
                creature[i][1] = creature[i][1]+move_vec[i][1]

    
    
        
    ##update energy and position
    energy -=0.4*np.sqrt(2*np.linalg.norm(move_vec,axis=1)**2+0.05*sense)
    
    return creature,energy


def prey_move(my_prey, prey, pred, my_energy, my_sense, my_speed, food, prey_sensed, pred_sensed,food_sensed):
    
    new_prey = my_prey.copy()
    new_energy = my_energy.copy()
    move_vec = np.array([np.random.normal(loc = 0, scale = s,size = 2) for s in my_speed])
    
    for i,p in enumerate(my_prey):
        if food_sensed[i][2] != None:
            move_to_food = np.array(food[food_sensed[i][2]]) 
            move_to_food = move_to_food - np.array([p[0],p[1]])
            if np.abs(move_to_food[0]) > (lim_x[1]/2): move_to_food[0] *= -1
            if np.abs(move_to_food[1]) > (lim_y[1]/2): move_to_food[1] *= -1
            if np.linalg.norm(move_to_food) > np.linalg.norm(move_vec[i]):
                move_vec[i] = move_to_food*(np.linalg.norm(move_vec[i]) / np.linalg.norm(move_to_food))
            else:
                move_vec[i] = np.copy(move_to_food)
        elif pred_sensed[i][2] != None:
            move_away = np.array(pred[pred_sensed[i][2]]) 
            move_away = move_away - np.array([p[0],p[1]])
            if np.abs(move_away[0]) > (lim_x[1]/2): move_away[0] *= -1
            if np.abs(move_away[1]) > (lim_y[1]/2): move_away[1] *= -1
            move_vec[i] = -1*move_away*(np.linalg.norm(move_vec[i]) / np.linalg.norm(move_away))
            
        #border checks        
        if p[0] +move_vec[i][0] < lim_x[0]:
            p[0]  = lim_x[1]+p[0] +move_vec[i][0]
        elif p[0] +move_vec[i][0] > lim_x[1]:
            p[0]  = p[0] +move_vec[i][0]-lim_x[1]
        else:
            p[0]  = p[0] +move_vec[i][0]
        
        if p[1] +move_vec[i][1] < lim_y[0]:
            p[1]  = lim_y[1]+p[1] +move_vec[i][1]
        elif p[1] +move_vec[i][1] > lim_y[1]:
            p[1] = p[1]+move_vec[i][1]-lim_y[1]
        else:
            p[1]  = p[1] +move_vec[i][1]

    ##update energy and position
    my_energy -=0.4*np.sqrt(2*np.linalg.norm(move_vec,axis=1)**2+0.05*np.array(my_sense))
    
    return my_prey, my_energy

def pred_move(my_pred, prey, pred, my_energy, my_sense, my_speed, food, prey_sensed, pred_sensed,food_sensed):
    
    new_pred = my_pred.copy()
    new_energy = my_energy.copy()
    move_vec = np.array([np.random.normal(loc = 0, scale = s,size = 2) for s in my_speed])
    
    for i,p in enumerate(my_pred):
        if prey_sensed[i][2] != None:
            move_to_prey = np.array(prey[prey_sensed[i][2]]) 
            move_to_prey = move_to_prey - np.array([p[0],p[1]])
            if np.abs(move_to_prey[0]) > (lim_x[1]/2): move_to_prey[0] *= -1
            if np.abs(move_to_prey[1]) > (lim_y[1]/2): move_to_prey[1] *= -1
            if np.linalg.norm(move_to_prey) > np.linalg.norm(move_vec[i]):
                move_vec[i] = move_to_prey*(np.linalg.norm(move_vec[i]) / np.linalg.norm(move_to_prey))
            else:
                move_vec[i] = np.copy(move_to_prey)
            
            #border checks        
        if p[0] +move_vec[i][0] < lim_x[0]:
            p[0]  = lim_x[1]+p[0] +move_vec[i][0]
        elif p[0] +move_vec[i][0] > lim_x[1]:
            p[0]  = p[0] +move_vec[i][0]-lim_x[1]
        else:
            p[0]  = p[0] +move_vec[i][0]
        
        if p[1] +move_vec[i][1] < lim_y[0]:
            p[1]  = lim_y[1]+p[1] +move_vec[i][1]
        elif p[1] +move_vec[i][1] > lim_y[1]:
            p[1] = p[1]+move_vec[i][1]-lim_y[1]
        else:
            p[1]  = p[1] +move_vec[i][1]
    
    ##update energy and position
    my_energy -=0.4*np.sqrt(2*np.linalg.norm(move_vec,axis=1)**2+0.05*np.array(my_sense))
    
    return my_pred, my_energy


    
def check_alive(prey,energy,sense,speed):
    return prey[energy>0],energy[energy>0],sense[energy>0],speed[energy>0]
    
def init_blobs(n,spawns = None,role = 'prey'):
    if role == 'prey':
        spawn_points = np.zeros((spawns,2))
        creature = np.zeros((n,2))
        sense = np.abs(np.random.normal(loc=75,scale=5,size=n))
        speed = np.abs(np.random.normal(loc=1.5,scale=0.5,size=n))
        energy =  np.ones(len(creature))*100
        
        q,r = divmod(n,spawns)
        for i in range(spawns):
            spawn_points[i] = np.random.uniform(lim_x[0]+128,lim_x[1]-128,size=2)
            if i==spawns-1:
                for j in range(q+r):
                    idx = i*(q)
                    creature[idx+j,:] = np.random.normal(loc = spawn_points[i],scale = 50, size=2) 
            else: 
                for j in range(q):
                    idx = i*(q)
                    creature[idx+j,:] = np.random.normal(loc = spawn_points[i],scale = 50, size=2)
    
    elif role == 'pred':
        creature = np.random.uniform(lim_x[0],lim_x[1],(n,2))
        sense = np.abs(np.random.normal(loc=125,scale=8,size=n))
        speed = np.abs(np.random.normal(loc=2,scale=0.5,size=n)) 
        energy =  np.ones(len(creature))*100
    
    return creature, energy, sense, speed
    
    
def spawn_food(food,spawns,new_food):
    if new_food == 0:
        return(food)
    num = int(new_food)
    spawn_point = np.random.randint(len(spawns),size=num)
    respawn = spawns[spawn_point]
    respawn += np.random.normal(loc = 0,scale = 50, size=(num,2))
    respawn[:,0] = respawn[:,0]%lim_x[1]
    respawn[:,1] = respawn[:,1]%lim_y[1]
    
    return np.concatenate((food,respawn))
    
    
def reproduce(prey,energy,sense,speed,role):
    if role == 'prey':
        able = energy>150
    elif role == 'pred':
        able = energy>150
    count = np.count_nonzero(able)
    new_prey = np.random.normal(loc=prey[able],scale=15,size=(count,2))
    if count > 0:
        new_prey[:,0] = new_prey[:,0]%lim_x[1]
        new_prey[:,1] = new_prey[:,1]%lim_y[1]
    new_sense = np.abs(np.random.normal(loc=sense[able],scale=20,size=(count)))
    new_speed = np.abs(np.random.normal(loc=speed[able],scale=0.5,size=(count)))
    if role == 'prey':
        energy[able] -= 100
    if role == 'pred':
        energy[able] -= 100
    
    return np.concatenate((prey,new_prey)), np.concatenate((energy,np.ones(count)*100)), np.concatenate((sense,new_sense)), np.concatenate((speed,new_speed))
    
    
def get_boxes(x_count,x_len,y_count,y_len,blobs):
    blob_boxes = []
    for x_c in range(int(x_count)):
            for y_c in range(int(y_count)):
                #split in boxes
                blob_box = blobs[blobs[:,0]<=(1+x_c)*x_len]
                blob_box = blob_box[blob_box[:,0]>(x_c)*x_len]
                blob_box = blob_box[blob_box[:,1]<=(1+y_c)*y_len]
                blob_box = blob_box[blob_box[:,1]>(y_c)*y_len]
                
                idxs = []
                for i in range(len(blob_box)):
                    idxs.append(np.where(blobs == blob_box[i])[0][0])
                    
                blob_boxes.append([blob_box,idxs])
    return blob_boxes
                
                
                
def init_boxes(box_count, sub_box_count, prey, pred, food):
    boxes = []
    for _ in range(box_count**2):
        boxes.append([[],[],[]])
    sub_boxes = []
    
    for _ in range(box_count**2*sub_box_count**2):
        sub_boxes.append([[],[],[]])
        
    for i,(x,y) in enumerate(prey):
        boxes[int(((x*box_count)//lim_x[1])*box_count + ((y*box_count)//lim_x[1]))][0].append([x,y,i])
        sub_boxes[int(((x*sub_box_count*box_count)//lim_x[1])*sub_box_count*box_count + ((y*sub_box_count*box_count)//lim_x[1]))][0].append([x,y,i])
    for i,(x,y) in enumerate(pred):
        boxes[int(((x*box_count)//lim_x[1])*box_count + ((y*box_count)//lim_x[1]))][1].append([x,y,i])
        sub_boxes[int(((x*sub_box_count*box_count)//lim_x[1])*sub_box_count*box_count + ((y*sub_box_count*box_count)//lim_x[1]))][1].append([x,y,i])
    for i,(x,y) in enumerate(food):
        boxes[int(((x*box_count)//lim_x[1])*box_count + ((y*box_count)//lim_x[1]))][2].append([x,y,i])
        sub_boxes[int(((x*sub_box_count*box_count)//lim_x[1])*sub_box_count*box_count + ((y*sub_box_count*box_count)//lim_x[1]))][2].append([x,y,i])
     
    return boxes, sub_boxes
    
    
def get_sub_boxes(box, box_count, sub_box_count):
    sub_boxes = []
    for i in range(sub_box_count):
        for j in range(sub_box_count):
            sub_boxes.append((sub_box_count*(box%box_count)+j)+sub_box_count*(box//box_count)*sub_box_count*box_count + i*sub_box_count*box_count)
    
    return np.array(sub_boxes)
    
def get_sb_layers(sub_box, box_count, sub_box_count): # returns indices of n-th layer ('ring') of subboxes around sub_box
    layers = []
    for layer in range(4):
        idxs = []
        for i in range(2*layer+1):
            for j in range(2*layer+1):
                if i not in [0,2*layer] and j not in [0, 2*layer]:
                    continue
                new_idx = ((sub_box-(layer*box_count*sub_box_count))+i*box_count*sub_box_count+(j-(layer))) % (box_count*sub_box_count)**2
                if new_idx %(box_count*sub_box_count) == 0 and j == 2*layer:
                    new_idx = (new_idx-(box_count*sub_box_count))%(box_count*sub_box_count)**2
                elif new_idx%(box_count*sub_box_count) == 14 and j == 0:
                    new_idx = (new_idx+(box_count*sub_box_count))%(box_count*sub_box_count)**2
                idxs.append(new_idx)
        layers.append(idxs)
    return layers
                 
    
def get_nearest(blob, lst):
    dist = []
    min_d = 1025
    min_idx = None
    for i,obj in enumerate(lst):
        d = np.sqrt(((blob[0]-obj[0])**2)+((blob[1]-obj[1])**2))
        if lim_x[1]/2 < d < np.sqrt(2*(4/5*lim_x[1])**2):
            if obj[0] < lim_x[1]/5 and lim_x[1]/5<obj[1]<4*lim_x[1]/5:
                d = np.sqrt(((blob[0]-(lim_x[1]+obj[0]))**2)+((blob[1]-obj[1])**2))
            elif obj[0] > 4*lim_x[1]/5 and lim_x[1]/5<obj[1]<4*lim_x[1]/5:
                d = np.sqrt(((blob[0]-(obj[0]-lim_x[1]))**2)+((blob[1]-obj[1])**2))
            elif obj[1] < lim_y[1]/5 and lim_x[1]/5<obj[0]<4*lim_x[1]/5:
                d = np.sqrt(((blob[0]-(obj[0]))**2)+((blob[1]-(lim_y[1]+obj[1]))**2))
            elif obj[1] > 4*lim_y[1]/5 and lim_x[1]/5<obj[0]<4*lim_x[1]/5:
                d = np.sqrt(((blob[0]-(obj[0]))**2)+((blob[1]-(obj[1]-lim_x[1]))**2))
            elif obj[0] < lim_x[1] and obj[1] < lim_x[1]:
                d = min(np.sqrt(((blob[0]-(obj[0]))**2)+((blob[1]-(obj[1]+lim_x[1]))**2)), (np.sqrt(((blob[1]-(obj[1]))**2)+((blob[0]-(obj[0]+lim_x[1]))**2))))
            elif obj[0] > lim_x[1] and obj[1] > lim_x[1]:
                d = min(np.sqrt(((blob[0]-(obj[0]))**2)+((blob[1]-(obj[1]-lim_x[1]))**2)), (np.sqrt(((blob[1]-(obj[1]))**2)+((blob[0]-(obj[0]-lim_x[1]))**2))))
            elif obj[0] < lim_x[1] and obj[1] > lim_x[1]:
                d = min(np.sqrt(((blob[0]-(obj[0]))**2)+((blob[1]-(obj[1]-lim_x[1]))**2)), (np.sqrt(((blob[1]-(obj[1]))**2)+((blob[0]-(obj[0]+lim_x[1]))**2))))
            elif obj[0] > lim_x[1] and obj[1] < lim_x[1]:
                d = min(np.sqrt(((blob[0]-(obj[0]))**2)+((blob[1]-(obj[1]+lim_x[1]))**2)), (np.sqrt(((blob[1]-(obj[1]))**2)+((blob[0]-(obj[0]-lim_x[1]))**2))))
        
        elif lim_x[1]/2 < d > np.sqrt(2*(4/5*lim_x[1])**2):
            d = min(np.sqrt(((blob[0]-(obj[0]-lim_x[1]))**2)+((blob[1]-(obj[1]-lim_x[1]))**2)),np.sqrt(((blob[0]-(obj[0]-lim_x[1]))**2)+((blob[1]-(obj[1]+lim_x[1]))**2)),np.sqrt(((blob[0]-(obj[0]+lim_x[1]))**2)+((blob[1]-(obj[1]-lim_x[1]))**2)), np.sqrt(((blob[0]-(obj[0]+lim_x[1]))**2)+((blob[1]-(obj[1]+lim_x[1]))**2)))

        
        if d < min_d:
            min_d = d
            min_idx =  obj[2]
        
        
    return [min_d, blob[2],min_idx]









